use utf8;
use strict;

binmode(STDOUT, ":utf8");

# リスト5
{
    package Person;
    use Moose;

    # アトリビュートの定義
    has 'name' => (
        is => 'rw',
        required => 1,
    );

    # メソッドの定義
    sub describe {
        my $self = shift;
        my $name = $self->name;
        print "$name";
    }

    my $person = Person->new( name => "Shawn" );
    $person->describe;
    print "\n";
}

# リスト6
{
    my $meta = Person->meta;
    print 
        $meta->isa( 'Class::MOP::Class' ) ?
            "\$meta is-a Class::MOP::Class" :
            "\$meta is-NOT-a Class::MOP::Class",
        "\n"
    ;
    print
        $meta->isa( 'Moose::Meta::Class' ) ?
            "\$meta is-a Moose::Meta::Class" :
            "\$meta is-NOT-a Moose::Meta::Class",
        "\n"
    ;
}

# リスト7
{
    package Employee;
    use Moose;
    extends 'Person';           # 親クラス

    has 'employer' => (         # アトリビュート
        is       => 'rw',
        isa      => 'Company',
        required => 1,
    );

    before describe => sub {    # メソッドモディファイヤ
        my $self = shift;
        my $company = $self->employer->name;
        print "所属 $company, 社員名 ";
    };
}
